// --- [ COMPA_ISR.S ] --------------------------------------------------------
//       03.10.12
//       tab = 3
// ----------------------------------------------------------------------------

#include  "avr/io.h"
#include  "global.h"

// ----------------------------------------------------------------------------

#if ASM == TRUE

// ----------------------------------------------------------------------------
// wird alle 20ms aufgerufen und setzt das Register GPIOR0 auf 1
// damit wird in main() der Start eines neuen Impulses fr die Servos signalisiert

.global TIMER0_COMPA_vect
.func TIMER0_COMPA_vect
TIMER0_COMPA_vect:

   push  R16
   ldi   R16, 1
   out   _SFR_IO_ADDR(GPIOR0), R16
   pop   R16
   reti

.endfunc

// ----------------------------------------------------------------------------
// wird aufgerufen, wenn die Dauer des Impulses abgelaufen ist.
// Der Timer1 wird gestoppt, alle Ausgnge fr die Servos auf low gesetzt
//
// Ausnahme:
// wenn die Impulsdauer lnger als 255 ist, dann muss die verbleibende Wartezeit
// in das compare-Register geladen werden, der Pin muss dabei auf HIGH bleiben.

.global TIMER1_COMPA_vect
.func TIMER1_COMPA_vect
TIMER1_COMPA_vect:

   push  R16
   in    R16, _SFR_IO_ADDR(SREG)
   push  R16
                                       // GPIOR1 auf 0 testen
   in    R16, _SFR_IO_ADDR(GPIOR1)     // GPIOR1 laden
   tst   R16
   breq  T1_a                          // wenn = 0, dann springen nach T1_a
                                       // wenn > 0, dann gehts hier weiter
   out   _SFR_IO_ADDR(OCR1A), R16      // ins Compare-Register laden
   eor   R16, R16                      // R16 lschen
   out   _SFR_IO_ADDR(GPIOR1), R16     // 0 zurckschreiben
   rjmp  T1_exit                       // die Arbeit ist damit beendet

T1_a:
   in    R16, _SFR_IO_ADDR(PORTB)
   ANDI  R16, (1<<PB0 | 1<< PB2)       // alle Servo-Pins auf 0 setzen
   out   _SFR_IO_ADDR(PORTB), R16

   eor   R16, R16                      // R16 auf 0 setzen
   out   _SFR_IO_ADDR(TCCR1), R16      // und in das Register TCCR1 schreiben

   ldi   R16, (1<<OCIE0A)              // Timer0 enablen
   out   _SFR_IO_ADDR(TIMSK), R16      // in das Register TIMSK schreiben

T1_exit:
   pop   R16
   out   _SFR_IO_ADDR(SREG), R16
   pop   R16
   reti

.endfunc

#endif
// --- [ end of file ] ---------------------------------------------------------
